#ifndef BON_SEM_H
#define BON_SEM_H

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>

#if defined(__GNU_LIBRARY__) && !defined(_SEM_SEMUN_UNDEFINED)
/* union semun is defined by including <sys/sem.h> */
#else
 /* according to X/OPEN we have to define it ourselves */
typedef union semun
{
  int val;                    /* value for SETVAL */
  struct semid_ds *buf;       /* buffer for IPC_STAT, IPC_SET */
  unsigned short int *array;  /* array for GETALL, SETALL */
  struct seminfo *__buf;      /* buffer for IPC_INFO */
} SEM;
#endif
// union semun arg;

class BonSem
{
public:

  BonSem() { m_semopen = false; m_semid = 0; m_semflg = IPC_CREAT | 0666; }

  // clear the semaphores and return an error code.
  int clear_sem();

  // create the semaphores
  int create(int sems);

  int get_semid();

  int decrement_and_wait(int nr_sem);

private:
  SEM m_arg;
  int m_semid;
  int m_semflg;
  bool m_semopen;
};

#endif

